Attribute VB_Name = "basDeclaration"
Option Explicit

'------------------------------------------------------------
' Return codes for PDF2ImageRun function.
Public Const PDF2IMAGE_OK = 0              ' No errors
Public Const PDF2IMAGE_ERR = 1             ' Unspecified error
Public Const PDF2IMAGE_ERR_BADKEY = 2      ' Bad license key
Public Const PDF2IMAGE_ERR_DIRCREATE = 3   ' Failed to create the output file/directory
Public Const PDF2IMAGE_ERR_READINGPDF = 4  ' Failed to read input document
Public Const PDF2IMAGE_ERR_PASSWORD = 5    ' The password required to open PDF is incorrect
Public Const PDF2IMAGE_ERR_CONVERT = 6     ' A conversion error

'------------------------------------------------------------
' 'mode' identifier passed in PDF2ImageCallback.
' The 'mode' can be used to determine whether a message is an error or
' a progress message.
Public Const PDF2IMAGE_ERROR = 1        ' Show the error message
Public Const PDF2IMAGE_MSG = 2          ' Report the message
Public Const PDF2IMAGE_GETPASS = 3      ' Get the password
Public Const PDF2IMAGE_OUT_FILENAME = 4 ' Reports the Saved File Names

'------------------------------------------------------------
' API function declarations

'------------------------------------------------------------
' Initialize PDF2Image with registration and license information.
' Although PDF2ImageInit is typically called only once (e.g. during the program
' startup), it can also be called multiple times without side effects.
'
' The first parameter is your username, the second parameter is your company name,
' and the last parameter is the license key supplied with your registration information.
'------------------------------------------------------------
Public Declare Function PDF2ImageInit Lib "..\..\lib\pdf2image.dll" _
    (ByVal user_name As String, _
     ByVal company As String, _
     ByVal license_key As String) As Integer

'------------------------------------------------------------
' Execute PDF2Image command string.
'
' PDF2ImageRun can be called multiple times to process PDF documents or folders
' with PDF documents. The function is completely thread safe, so it is possible to
' run many PDF2Image threads at the same time.
'
' @param command_str PDF2Image command string. For a detailed explanation of
' all options and syntax, please refer to section 4 in PDF2Image SDK Manual.
'
' @param funct (optional) a pointer to the callback function used to report error
' as well as other messages.
'
' @param user_data (optional) a pointer to custom data that you may want to
' pass to the callback function. NULL if you don't need to pass custom data.
'
' @return error code. A non-zero value indicates that an error was encountered.
'------------------------------------------------------------
Public Declare Function PDF2ImageRun Lib "..\..\lib\pdf2image.dll" _
    (ByVal command_str As String, _
     ByVal callback_funct As Long, _
     ByVal user_data As Long) As Integer


